/*****************************************
*                                        *
*   HeX Dump                             *
*                                        *
*                by Qen(C)               *
*                e-mail : qen@246.ne.jp  *
*                                        *
*****************************************/
#include  <stdio.h>
#include  <stdlib.h>
#ifdef _QC
	#include  <malloc.h>
	#include  <conio.h>
#endif

void	help();

#ifdef _QC
	#define	TIMES	200
	#define	BLOCK	16
	#define	COL	32
#else
	#define	TIMES	200
	#define	BLOCK	64
	#define	COL	32
#endif

#ifdef	_QC
	#define		INTMAX 0x7fff
#else
	#define		INTMAX 0x7fffffff
#endif

FILE	*src;
FILE	*dst;

void	main(int argc, char *argv[])
{
	char	SRC[128];
	char	DST[128];
	char	*inc;
	char	Line[256];
	char	*Buf;
	char	*WBuf;
	char	*OBuf;
	int		file_no=0;
	int		char_no=0;
	long		cnt;
	int		c,i,j,k;
	int		ocnt;
	int		size;
	int		csize;
	int		rsize;
	int		STP;
	int		ENP;
	int		WID;
	long		readsize;
	long		readp;
	long		recno;

	if(argc < 2){
		help();
		exit(0);
	}
	
	SRC[0]=DST[0]='\0';
	size=256;
	STP=1;
	ENP=INTMAX;
	WID=16;
	i=1;
	while(i<argc){
		if(*argv[i]=='-'){
			switch (*(argv[i]+1)){
				case	'I':
				case	'i':
					if(strlen(argv[i]) > 2){
						strcpy(SRC,argv[i]+2);
					}else{
						i++;
						strcpy(SRC,argv[i]);
					}
					break;
				case	'O':
				case	'o':
					if(strlen(argv[i]) > 2){
						strcpy(DST,argv[i]+2);
					}else{
						i++;
						strcpy(DST,argv[i]);
					}
					break;
				case	'R':
				case	'r':
					if(strlen(argv[i]) > 2){
						size=atoi(argv[i]+2);
					}else{
						i++;
						size=atoi(argv[i]);
					}
					if(size < 0){
						size=0;
					}
					break;
				case	'S':
				case	's':
					if(strlen(argv[i]) > 2){
						STP=atoi(argv[i]+2);
					}else{
						i++;
						STP=atoi(argv[i]);
					}
					if(STP < 0){
						STP=0;
					}
					break;
				case	'E':
				case	'e':
					if(strlen(argv[i]) > 2){
						ENP=atoi(argv[i]+2);
					}else{
						i++;
						ENP=atoi(argv[i]);
					}
					if(ENP < 0){
						ENP=INTMAX;
					}
					break;
				case	'W':
				case	'w':
					WID=32;
					break;
			}
		}
		i++;
	}

#ifdef TEST
	printf("I:%s\n",SRC);
	printf("O:%s\n",DST);
	printf("R:%d\n",size);
	printf("S:%d\n",STP);
	printf("E:%d\n",ENP);
	printf("W:%d\n",WID);
	getch();
#endif

	if((src=fopen(SRC,"rb"))==NULL){
		fprintf(stderr,"Open err!!(%s)\n",SRC);
		exit(1);
	}
	if((dst=fopen(DST,"w+b"))==NULL){
		dst=stdout;
	}
	

	cnt=0;
	recno=0;
	c=0;
	ocnt=0;

	Buf=malloc(size+1);
	WBuf=malloc(size*TIMES+1);
	OBuf=malloc(1024*BLOCK);
	inc=malloc(WID);
	csize=0;

	while(c!=EOF){
		i=j=0;
		readsize=readp=0;

/* Read */
		while(i<TIMES){
			rsize=fread(Buf,1,size,src);
			if(rsize>0){
				memmove(WBuf+(i*size),Buf,rsize);
			}
			readsize+=rsize;
			if(rsize<size){
				c=EOF;
				break;
			}
			i++;
		}

/* Get */
		while(readp<readsize){
			i=0;
			if(csize==0){
				recno++;

				if(recno < STP){
					readp+=size;
					continue;
				}

				if(recno > ENP){
					c=EOF;
					break;
				}

				if(size > 0){
//					sprintf(OBuf+ocnt,"\n\nRECORD %ld\n\n",recno);
					sprintf(OBuf+ocnt,"\n\nRECORD %ld\n\n",recno);
					ocnt+=strlen(OBuf+ocnt);
				}
			}

			while(i<WID){
				if((readp+i)<readsize){
					j=i;
					inc[i]=WBuf[readp+i]&0xff;
				}else{
					inc[i]=0;
				}

				csize++;
				i++;
				if((size>0)&&(csize>=size)){
					csize=0;
					break;
				}
			}

			if(j==0){
				break;
			}

			sprintf(Line,"%08ld ",cnt);
			cnt=cnt+(long)i;
			readp+=i;

			k=9;
			for(j=0;j<i;j++){
				if(j%2){
					sprintf(Line+k,"%02X ",inc[j]&0xff);
					k+=3;
				}else{
					sprintf(Line+k,"%02X",inc[j]&0xff);
					k+=2;
				}
			}

			for(;i<WID;i++){
				if(i%2){
					sprintf(Line+k,"   ");
					k+=3;
				}else{
					sprintf(Line+k,"  ");
					k+=2;
				}
				inc[i]=' ';
			}

			for(i=0;i<WID;i++){
				if(inc[i]>=0x20 && inc[i]<=0x7e)
					sprintf(Line+i+WID/2*5+9,"%c",inc[i]);
				else
					sprintf(Line+i+WID/2*5+9,".");
			}

			sprintf(OBuf+ocnt,"%s\n",Line);
			ocnt+=strlen(OBuf+ocnt);

			if(ocnt > (1024*BLOCK-256)){
				fwrite(OBuf,1,ocnt,dst);
				ocnt=0;
			}
		}
	}
	if(ocnt){
		fwrite(OBuf,1,ocnt,dst);
	}
	fclose(src);
	fclose(dst);
}

void	help()
{
	fprintf(stderr,"\nHXD ver1.04  written for MSDOS by Qen(c)1995.3.11");
	fprintf(stderr,"\nHXD ver1.04a written for Linux by Qen(c)1999.4.27\n");
	fprintf(stderr,"\n hxd -Iname [-Oname] [-Rn] [-Sn] [-En] [-W]\n\n");
	fprintf(stderr,"\n             -I: input file name");
	fprintf(stderr,"\n             -O: output file name         (default:stdout)");
	fprintf(stderr,"\n             -R: record length            (default:256)");
	fprintf(stderr,"\n             -S: print start record number(default:1)");
	fprintf(stderr,"\n             -E: print end record number  (default:%d)",INTMAX);
	fprintf(stderr,"\n             -W: print with double column (default:16 col)");
	fprintf(stderr,"\n");
	fprintf(stderr,"\n ex) hxd -i data -s 2 -e 5 -r 132");
	fprintf(stderr,"\n\n");
}
